; **** countdowntimer.asm ****
; letzter Stand :18.04.2014  -erstellt: Lothar Gde



;-------------- countdowntimer stellen -------------------------------------------------------------
; Modus countdowntimer stellen einschalten
		lds tmp,tastencode_guelt    	;gltiger tastencode 
		cpi tmp,0x0C					;Taste + und Taste - gleichzeitig gedrckt
		breq cd10_3
		mov tmp,modus_2
		cpi tmp,0b00100000				;BA Countdown Timer eingestellt ?
		breq cd10
		rjmp cd99						;Sicherheit
	
cd10_3: lds tmp,tastencode_guelt_hist   ;gltiger tastencode 
		cpi tmp,0						;0=  keine Taste bettigt 
		breq cd10_4	
		rjmp cd14_4	

cd10_4: lds tmp,countdowntimer
		sbrc tmp,0	        			;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer=0 ->von Minuten einstellen auf Sekunden einstellen umschalten 
		rjmp cd10_2						;von Minuten einstellen auf Sekunden einstellen umschalten
		rjmp cd11_4						;CD einstellen erneut einschalten
				
cd10:	lds tmp,countdowntimer
		sbrc tmp,7	         			;berspringe nchsten Befehl wenn bit7 (von 0-7) von countdowntimer =0 ->Count Down Timer Piezosignal ein
		rjmp cd30
		sbrc tmp,5	         			;berspringe nchsten Befehl wenn bit5 (von 0-7) von countdowntimer =0 ->Count Down Timer Zugmagnet ein
		rjmp cd30
		sbrc tmp,6	         			;berspringe nchsten Befehl wenn bit6 (von 0-7) von countdowntimer =0 ->warten auf Count Down Timer Neustart
		rjmp cd31
		sbrc tmp,3	         			;berspringe nchsten Befehl wenn bit3 (von 0-7) von countdowntimer =0 ->Sekunde blinkt und Tasten (Taste + und Taste -) noch gedrckt (wird gelscht, wenn keine Taste mehr gedrckt ist)
		rjmp cd10_5
		sbrc tmp,1	         			;berspringe nchsten Befehl wenn bit1 (von 0-7) von countdowntimer =0 ->Count Down Timer luft
		rjmp cd19						;Count Down Timer rckwrts zhlen
		sbrs tmp,0	         			;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer =1 ->Count Down Timer stellen
		rjmp cd11_4						;wenn 0 dann Sprung zum Count Down Timer einstellen einschalten
		lds tmp,modus_2_hist   			;1. Programmdurchlauf nach Reset? 
		cpi tmp,0						;0=  keine Tasten bettigt 
		breq cd10_1
		rjmp cd14						;Count Down Timer stellen ist aktiv


cd10_5:	lds tmp,tastencode_guelt    	;gltiger tastencode 
		cpi tmp,0x00					;Taste + und Taste - gleichzeitig gedrckt
		brne cd14						;zu Count Down Timer stellen springen
		lds tmp,countdowntimer
		cbr tmp,0b00001000				;lsche bit 3 -> Sekunde stellen eingeschaltet und Tasten (Taste + und Taste -) noch bettigt
		sbr tmp,0b00010000				;setze bit 4  -> Sekunde blinkt und keine Taste mehr bettigt
		sts countdowntimer,tmp
		rjmp cd14						;Count Down Timer stellen ist aktiv

;stellt von Minuten einstellen auf Sekunden einstellen bzw auf Einstennmode beenden, wenn steigende Flanke von Taste Count Down Timer kommt 
cd10_1: lds tmp,countdowntimer
		sbrc tmp,2	        			;berspringe nchsten Befehl wenn bit2 (von 0-7) von modus_1=0 ->Minute blinkt
		rjmp cd10_2						;wenn gesetzt, dann Sekunden einstellen einschalten
		rjmp cd14_3						;wird nach der Sekundeneinstellung nochmal Tasten (Taste + und Taste -) gedrckt, dann soll Enstellmode beendet werden und nicht in 
										;Einstellung Minuten gesprungen werden
cd10_2:	sbrc tmp,4						;wenn Einstellmode beendet werden soll, dann sofort zu cd14 springen nicht cd_sekunde lschen
		rjmp cd14						
		cbr tmp,0b00000100 				;lsche bit 2 Minute einstellen /Minute blinkt
		sbr tmp,0b00001000				;Sekunden stellen eingeschaltet und Tasten (Taste + und Taste -) noch bettigt
		sts countdowntimer,tmp
		clr tmp							;Zhler auf 0 stellen
		sts timeout_cdstellen,tmp
		sts cd_sekunde, tmp				;auf 0 setzen, falls schon gezhlt wurde, so dass bei Korrektur immer bei 0 begonnen wird 
		rjmp cd14						;Count Down Timer stellen ist aktiv

;*************** Count Down Timer stellen einschalten *************************************
cd11_4:	sbrs modus_2,5	  			;berspringe nchsten Befehl wenn bit5 (von 0-7) von modus_2=1 ->Betriebsart count down timer muss aktiv sein
	 	rjmp cd99					;nach Abbruch count down timer darf der Einstellmode nicht einschalten
		clr tmp						;Zhler auf 0 stellen
		sts timeout_cdstellen,tmp
		lds tmp,countdowntimer
		sbr tmp,0b00000101	 		;setzte bit 0 im countdowntimer (Count Down Timer stellen); bit 2 (Minuten blinkt)
		cbr tmp,0b11100010			;lsche bits
		sts countdowntimer,tmp
		mov tmp,modus_2
		sts cd_modus_2,tmp	        ;Betriebsart retten 
		sbr modus_1,0b10000000	    ;setze bit 7 = sperrt alle anderen Einstellmodi
		rjmp cd14							


; Count Down Timer mit Tasten (Taste + oder Taste -) stellen
cd14:  	lds tmp,countdowntimer
		sbrc tmp,1		 			;berspringe nchsten Befehl wenn bit1 (von 0-7) von countdowntimer =0 ->wenn Count Down Timer zhlen ein, dann zhlen
		rjmp cd19				
		sbrc tmp,0	         		;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer=0 ->Count Down Timer stellen
		rjmp cd14_4
		rjmp cd99					;wenn 0 dann sprung zu Count Down Timer

; Variablen fr Unterprogramm zusammenstellen
cd14_4:	lds tmp,timeout_cdstellen	;timeout im Unterprogramm laden
		sts up_timeout,tmp
	
		lds tmp,cd_minute			;Minute im Unterprogramm laden
		sts up_minute,tmp
					
		lds tmp,cd_sekunde			;Sekunde im Unterprogramm laden
		sts up_sekunde,tmp

		lds tmp,countdowntimer
		andi tmp,0b11111110			;Bit 0 ausblenden, damit die Sekunden in 10-er Schritten gezhlt werden
		sts up_modus_1,tmp			;Minuten oder Sekunden zhlen

		call uhr_stellen			;Unterprogramm Uhr stellen


; Variablen zurckschreiben
		lds tmp,up_timeout			;timeout aus Unterprogramm zurckschreiben
		sts timeout_cdstellen,tmp
		
		lds tmp,up_sekunde			;Sekunde aus Unterprogramm zurckschreiben
		sts cd_sekunde,tmp
	
		lds tmp,up_minute			;Minute aus Unterprogramm zurckschreiben
		sts cd_minute,tmp
		

;Count Down Timer- Modus beenden (Modus Count Down Timer stellen verlassen)
		lds tmp,countdowntimer
		sbrc tmp,2	        		;berspringe nchsten Befehl wenn bit2 (von 0-7) von countdowntimer=0 ->Minute blinkt
		rjmp cd14_8					;wenn gesetzt, dann Stunden zhlen eingeschaltet
		sbrs tmp,4	        		;berspringe nchsten Befehl wenn bit4 (von 0-7) von countdowntimer=1 ->Sekunde blinkt und Tasten (Taste + und Taste -) gedrckt nachdem vorher keine Taste gedrckt war
		rjmp cd14_8					;Sekunde blinkt und Tasten (Taste + und Taste -) noch gedrckt (wird gelscht, wenn keine Taste mehr gedrckt)
		
		lds tmp,tastencode_guelt    ;gltiger tastencode 
		cpi tmp,0x0C				;Tasten (Taste + und Taste -) gleichzeitig gedrckt
		breq cd14_9					;Einstellmode abbrechen ohne timeout abzuwarten
		rjmp cd14_8

cd14_9: lds tmp,countdowntimer
		cbr tmp,0b00010000			;lsche bit 4 (Sekunde blinkt)
		sts countdowntimer,tmp
		rjmp cd14_3
		
cd14_8:	sbrs tmp1,0	  				;tmp1 kommt aus UP uhr_stellen ;berspringe nchsten Befehl wenn bit0 (von 0-7) von tmp1=0 ->Count Down Timer- stell Modus beenden	
		rjmp cd99	  				;Count Down Timer- stell Modus nicht beenden	


;**********************	Count Down Timer einstellen beenden ********************
cd14_3:	cbr modus_1,0b10000000		; lsche bit 7 = sperrt alle anderen Einstellmodi
		lds tmp,cd_minute			; Betriebsart zurckschreiben wenn beim Einstellen des Count Down Timer fr Minute und Sekunde 0 eingestellt ist (Tasten (Taste + und Taste -) versehentlich gedrckt)
		tst tmp						; Minute =0?				
		brne cd14_6					; wenn nicht, dann Count Down Timer einstellen beenden
		lds tmp1,cd_sekunde
		tst tmp1					; Sekunde =0?				
		brne cd14_6					; wenn nicht, dann Count Down Timer einstellen beenden
		rjmp cd14_5					; wenn keine Zeit eingestellt wurde, dann Count Down Timer abbrechen


cd14_6:	lds tmp,countdowntimer
		cbr tmp,0b00001101	 		;lsche bit 0, bit 2 und bit 3  countdowntimer (Taste Count Down Timer stellen) 
		sbr tmp,0b00000010			;setze bit 1 Count Down Timer eingestellt, 
		sts countdowntimer,tmp
	
		clr tmp						;Zhler auf 0 stellen
		sts timeout_cdstellen,tmp
		rjmp cd99		

cd14_5: clr tmp						;Zhler auf 0 stellen
		sts timeout_cdstellen,tmp
		sts countdowntimer,tmp
		rjmp cd26					; Piezosignalgeber 5x ein




;-------------- countdowntimer luft (Timer rckwrts zhlen) -------------------------------------------------------------
cd19: 	lds tmp,countdowntimer
		sbrc tmp,0		 		;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer =0 ->wenn Count Down Timer stellen aus, dann kann gezhlt werden
		rjmp cd99		 		;wenn Count Down Timer stellen luft, dann nicht zhlen
		sbrs modus_2,5	 		;berspringe nchsten Befehl wenn bit5 (von 0-7) von modus_2=0 -> wenn Count Down Timer aktiv- dann zhlen
		rjmp cd99 	 			;wenn Count Down Timer ausgeschaltet dann nicht zhlen


;-------------- ist Count Down Timer abgelaufen? Wert 0:00:59 -------------------------------------------------------------
		lds tmp,cd_sekunde
		lds tmp1,cd_minute
		lds tmp2,cd_stunde
		tst tmp2				; Stunde =0?				
		brne cd19_1				; wenn nicht, dann weiter zhlen
		tst tmp1				; Minute =0?				
		brne cd19_1				; wenn nicht, dann weiter zhlen
		cpi tmp,12				; 12s vor Ablauf der Zeit Piezosignal einschalten
		breq cd27 				; muss gemacht werden, bevor der Zugmagnet angezogen hat, da sonst nicht genug Spannung vorhanden ist um den Piezo anzusteuern (Lautstrke schwankt)
		tst tmp					; Sekunde =0?				
		brne cd19_1				; wenn nicht, dann weiter zhlen
		rjmp cd26				; 0:00 ist erreicht

; kurz vor Ablauf der Zeit Piezosignal 1x erzeugen
cd27:	mov tmp,viertelsek
		cpi tmp,2
		brne cd19_1
		lds tmp,piezo		   	 ;Signalgeber
		sbr tmp,0b00000001		 ;bit0=1 -> Signalgeber ein anstossen
		sts piezo,tmp
		rjmp cd19_1

;-------------- jede Sekunde Count Down Timer runterzhlen  -------------------------------------------------------------
cd19_1:	lds tmp,countdowntimer
		cbr tmp,0b11000000	 	;lsche bit 6 und bit 7 countdowntimer (Count Down Timer ist abgelaufen) 
		sts countdowntimer,tmp

		lds tmp,imp
		sbrs tmp,2			    ;1,0 s bersprige nchsten Befehl, wenn bit 2 von impuls =0 
		rjmp cd99				;kein Sekundenimpuls vorhanden 


;-------------- Sekunden zhlen -------------------------------------------------------------
		lds tmp,cd_sekunde
		dec tmp
		cpi tmp,0xFF			;
		breq cd21
cd20:   sts  cd_sekunde,tmp		;Sekunden speichern, kein berlauf
		rjmp cd99

;-------------- Minuten zhlen -------------------------------------------------------------
cd21:   ldi tmp,59				;Sekunde auf 59 setzen
		lds tmp1,cd_minute		;
		dec tmp1				;Minute zhlen
		cpi tmp1,0xFF
		breq cd23
cd22:	sts cd_minute,tmp1
		rjmp cd20

;-------------- Stunden zhlen -------------------------------------------------------------
cd23:   ldi tmp1, 59			;Minute auf 59 setzen		   
	    lds tmp2,cd_stunde		;
	    dec tmp2				;Stunde zhlen
	    cpi tmp2,0xFF
	    breq cd24
cd25:   sts cd_stunde, tmp2
		rjmp cd22
cd24:	ldi tmp2,0				;Stunde auf 0 setzen
		rjmp cd25

;-------------- Zeit ist abgelaufen -------------------------------------------------------------
cd26:	lds tmp,countdowntimer
		sbrc tmp,7	         	;berspringe nchsten Befehl wenn bit7 (von 0-7) von countdowntimer =0 ->Count Down Timer abgelaufen 
		rjmp cd99				;Bit 7 ist bereits gesetzt	
		lds tmp,countdowntimer
		sbr tmp,0b10100000	 	;bit 7 countdowntimer (Count Down Timer ist abgelaufen, piezo wird noch 5x (je Minute 1x) angestoen, Bit 5 Zugmagnet ein 
		cbr tmp,0b00000010	 	;lsche bit 1 countdowntimer (Count Down Timer luft) 
		sts countdowntimer,tmp

		ldi tmp,5				; 5 Wiederholungen
		sts cd_piezo_w,tmp		; Anzahl Wiederholungen fr Piezosignal
		ldi tmp, 240			; je Minute eine Wiederholung
		sts cd_piezo_z,tmp		; Zeit zwischen den Wiederholungen des Piezosignals
		rjmp cd99

;-------------- Wenn Zeit abgelaufen, dann Zugmagnet schalten, danach Piezosignal 5x wiederholen -------------------------------------------------------------
;***----------- Zugmagnet schalten --------------***
cd30:   sbic pinb,5 			; wenn Zugmagnet noch eingeschaltet dann nicht Piezosignal einschalten
	    rjmp cd30_4
		rjmp cd30_5
; wenn bit 7 von countdowntimer gesetzt, dann wird der Zugmagnet in der ISR von Timer 2 eingeschaltet. Nach 250ms wird 
; der Zugmagnet in der ISR von Timer 2 wieder zurckgesetzt. 
cd30_4:	lds tmp,countdowntimer	;wenn Zugmagnet ein, dann Bit 5 lschen, damit in der ISR PB5 gelscht werden kann 
		cbr tmp,0b00100000	 	;lsche bit 5 Zugmagnet aus
		sts countdowntimer,tmp
		rjmp cd99

;***----------- Piezosignal 5x wiederholen --------------***
cd30_5:	lds tmp,countdowntimer
		sbrc tmp,5	         	;berspringe nchsten Befehl wenn bit5 (von 0-7) von countdowntimer =0 ->Count Down Timer abgelaufen Bit 5 Hubmagnet ein 
		rjmp cd99				;erst weiter machen, wenn der Bit 5 gelscht ist und der Hubmagnet aus ist	

		lds tmp,tastencode_guelt ;gltiger tastencode 
		cpi tmp,0x04			 ;Taste + gedrckt, dann Wiederholungen fr Piezosignal abbrechen
		breq cd30_3				 ;Wiederholungen fr Piezosignal abbrechen
		cpi tmp,0x08			 ;Taste - gedrckt, dann Wiederholungen fr Piezosignal abbrechen
		breq cd30_3				 ;Wiederholungen fr Piezosignal abbrechen

		lds tmp, cd_piezo_w
		cpi tmp,0
		breq cd99				;Piezosignal wurde schon 5x wiederholt, deshalb nichts machen

		lds tmp,imp				;Zeit wird im 0.25s Takt herunter gezhlt
		sbrc tmp,0			  	;0,25 s bersprige nchsten Befehl, wenn bit 0 von impuls =0 
		rjmp cd30_1				;Zeit gegen 0 zhlen
		rjmp cd99

cd30_1: lds tmp,cd_piezo_z
		dec tmp
		sts cd_piezo_z,tmp		 ;Zeit zwischen den Wiederholungen des Piezosignals
		cpi tmp,0
		breq cd30_2				 ;Piezo ein
		rjmp cd99

;**** ----------- Piezo ein ------------ **** --------------------------------------------
cd30_2:	lds tmp,piezo		   	 ;Signalgeber
		sbr tmp,0b00000001		 ;bit0=1 -> Signalgeber ein anstossen
		sts piezo,tmp
		ldi tmp, 240			 ;je Minute eine Wiederholung
		sts cd_piezo_z,tmp		 ;Zeit zwischen den Wiederholungen des Piezosignals
		lds tmp,cd_piezo_w
		dec tmp
		sts cd_piezo_w,tmp		 ;Anzahl Wiederholungen fr Piezosignal
		cpi tmp,0				 ;Piezosignal wurde 5x wiederholt
		breq cd30_3
		rjmp cd99

cd30_3: lds tmp,countdowntimer
		sbr tmp,0b01000000	 	 ;bit 6 countdowntimer (warten auf Count Down Timer Neustart) 
		cbr tmp,0b10000000	 	 ;lsche bit 7  countdowntimer (Count Down Timer Piezosignal 5x ausgelst) 
		sts countdowntimer,tmp
		clr tmp
		sts cd_piezo_w,tmp
		sts cd_piezo_z,tmp		 ;Zeit zwischen den Wiederholungen des Piezosignals
		rjmp cd99

;-------------- Piezosignal wurde 5x wiederholt warten auf Count Down Timer Neustart-----------------------
;bleibt so lange in der Schleife, bis Tasten (Taste + und Taste -) bettigt wird -> dann wird Marke cd10_3 angesprungen
	
cd31:	rjmp cd99	;warten auf Neustart Count Down Timer
		


cd99:	nop 							; Ende
