; **** uhranzeige.asm ****
; letzter Stand :27.10.2019  -erstellt: Lothar Gde

	


;-------------------------------------------------------------------------------------------------------------------------------------------------------
;***** Anzeige blinken uhr (Sekunde) *****	
ur39: 
	 	sbrc modus_2,5	 ;berspringe nchsten Befehl wenn bit5 (von 0-7) von modus_2=0 -> wenn kein Count Down Timer aktiv- dann weiter
		rjmp ur26_6	 	 ;wenn Count Down Timer eingeschaltet, dann unterscheiden, ob Einstellmode oder Anzeigemode aktiv

; *************Sollwerte fr Minute umladen ******************
;------------------------------------- countdowntimer ----------------------------------------------------------
ur26_6:	  lds tmp,countdowntimer
		  sbrc tmp,6		 		;berspringe nchsten Befehl wenn bit6 (von 0-7) von countdowntimer =0 -> countdowntimer beendet warten auf Neustart 
		  rjmp ur26_6_2	 			;Striche anzeigen und aktuellen Anzahl der Piezosignale
		  sbrc tmp,7		 		;berspringe nchsten Befehl wenn bit7 (von 0-7) von countdowntimer =0 ->5x Piezosignal ein luft 
		  rjmp ur26_6_2	 			;Striche anzeigen und aktuellen Anzahl der Piezosignale
		  sbrs tmp,0		 		;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer =1 ->Count Down Timer stellen
		  rjmp ur26_6_1	 			;kein Einstellmode, nur anzeigen
		  lds tmp2,cd_sekunde  		;Sollwert ->Count Down Timer stellen - Anzeige fr Blinken oder Daueranzeige
		  lds tmp,countdowntimer
		  sbrc tmp,2	         	;berspringe nchsten Befehl wenn bit2 (von 0-7) von countdowntimer =0 ->Count Down Timer Minute blinkt
		  rjmp ur22					;wenn gesetzt, dann Minute nicht blinken
		  lds tmp,tastencode_guelt	;gltiger tastencode 
		  cpi tmp,0x00				;00 = keine Taste bettigt und Tasten entprellt und zeitverzgert
		  breq ur26_10				;Anzeige blinken lassen
		  cpi tmp,0x0C				;0x0C = fr Taste + und Taste - gleichzeitig bettigt -> muss schon blinken, wenn Count Down Timer Stellmodus eingeschaltet wird
		  breq ur26_10				;Anzeige blinken lassen
		  rjmp ur22					;darf nicht blinken, damit man whrend des Stellens die Anzeige sieht
ur26_6_1: lds tmp2,cd_sekunde 		;aktuellen Wert Count Down Timer Sekunde anzeigen
		  rjmp ur22					; 

ur26_6_2: ldi tmp,$10				; "-" anzeigen
		  lds tmp2,countdowntimer	
		  sbrc tmp2,6		 		;berspringe nchsten Befehl wenn bit6 (von 0-7) von countdowntimer =0 ->countdowntimer beendet warten auf Neustart 
		  rjmp ur26_6_3				;"-" anzeigen
		  lds tmp1,cd_piezo_w		; Anzahl Piezosignale, die noch ausgegeben werden mssen
		  rjmp ur25

ur26_6_3: ldi tmp1,$10				; "-" anzeigen
		  rjmp ur25

ur26_10: rjmp ur26				; Sprung zu weit


;--------------------- Wert fr blinken laden------------------------------------------------------------------------------

ur26:	lds tmp,imp
		sbrc tmp,2			    ;1,0 s bersprige nchsten Befehl, wenn bit 2 von impuls =0 (Anzeige ein)
		rjmp ur23
		sbrc tmp,1			    ;0,5s  bersprige nchsten Befehl, wenn bit 1 von impuls =0 (Anzeige aus)
		rjmp ur22
		rjmp um10

ur23:   ldi tmp,$ff				;Anzeige aus
		ldi tmp1,$ff	
		rjmp ur25

;---------------------------------------------------------------------------------------------------	
ur22:	rjmp ur28				;weiter im Programm
ur28:	mov tmp,tmp2			; tmp2 =  Uhr (Sekunde)
		

;dual in 2 Byte BCD wandeln
ur25_1:	rcall dual12bcd			;dual in 2 Byte BCD wandeln
   		rjmp ur25
;---------------------------------------------------------------------------------------------

ur25:	lds tmp2,sek_01_hist	;Prfung, ob sich der aktuelle Wert zum Hist.- Wert gendert hat
		cp tmp,tmp2
		breq um01_1				;wenn keine nderung, dann zur nchsten Anzeigestelle
  
  		sts sek_01_hist,tmp		;History speichern	
		
		ldi tmp2,0b10000000		;Maske zum Ausblenden der vorherigen Anzeige lcd_u1:

;---------------------------------------------------------------------------------------------
; *** Auswertung Sekunde 1-er Stelle *** 
;---------------------------------------------------------------------------------------------

		cpi	tmp,$0				;vergleiche Zhlerstand
		breq u_xx_x0a			;Anzeige Sekunde 1-er Stelle 0
		cpi	tmp,$1				;vergleiche Zhlerstand
		breq u_xx_x1a			;Anzeige Sekunde 1-er Stelle 1
		cpi	tmp,$2				;vergleiche Zhlerstand
		breq u_xx_x2a			;Anzeige Sekunde 1-er Stelle 2
		cpi	tmp,$3				;vergleiche Zhlerstand
		breq u_xx_x3a			;Anzeige Sekunde 1-er Stelle 3
		cpi	tmp,$4				;vergleiche Zhlerstand
		breq u_xx_x4a			;Anzeige Sekunde 1-er Stelle 4
		cpi	tmp,$5				;vergleiche Zhlerstand	
		breq u_xx_x5a			;Anzeige Sekunde 1-er Stelle 5
		cpi	tmp,$6				;vergleiche Zhlerstand
		breq u_xx_x6a			;Anzeige Sekunde 1-er Stelle 6
		cpi	tmp,$7				;vergleiche Zhlerstand
		breq u_xx_x7a			;Anzeige Sekunde 1-er Stelle 7
		cpi	tmp,$8				;vergleiche Zhlerstand	
		breq u_xx_x8a			;Anzeige Sekunde 1-er Stelle 8	
		cpi	tmp,$9				;vergleiche Zhlerstand
		breq u_xx_x9a			;Anzeige Sekunde 1-er Stelle 9
		cpi	tmp,$a				;vergleiche Zhlerstand
		breq u_xx_xaa			;Anzeige Sekunde 1-er Stelle a
		cpi	tmp,$b				;vergleiche Zhlerstand
		breq u_xx_xba			;Anzeige Sekunde 1-er Stelle b
		cpi	tmp,$c				;vergleiche Zhlerstand
		breq u_xx_xca			;Anzeige Sekunde 1-er Stelle c
		cpi	tmp,$d				;vergleiche Zhlerstand
		breq u_xx_xda			;Anzeige Sekunde 1-er Stelle d
		cpi	tmp,$e				;vergleiche Zhlerstand
		breq u_xx_xea			;Anzeige Sekunde 1-er Stelle e
		cpi	tmp,$f				;vergleiche Zhlerstand
		breq u_xx_xfa			;Anzeige Sekunde 1-er Stelle f
		cpi	tmp,$10				;vergleiche Zhlerstand
		breq u_xx_xha			;Anzeige Sekunde 1-er Stelle "-"
		cpi	tmp,$ff				;vergleiche Zhlerstand
		breq u_xx_xga			;Anzeige Sekunde 1-er Stelle ausgeschaltet
		rjmp u2					;Sicherheitsabfrage

um01_1:  rjmp um01				;Sprungdistanz zu weit


u_xx_x0a:rjmp u_xx_x0           ;Sprungdistanz zu weit
u_xx_x1a:rjmp u_xx_x1           ;Sprungdistanz zu weit
u_xx_x2a:rjmp u_xx_x2           ;Sprungdistanz zu weit
u_xx_x3a:rjmp u_xx_x3           ;Sprungdistanz zu weit
u_xx_x4a:rjmp u_xx_x4           ;Sprungdistanz zu weit
u_xx_x5a:rjmp u_xx_x5           ;Sprungdistanz zu weit
u_xx_x6a:rjmp u_xx_x6           ;Sprungdistanz zu weit
u_xx_x7a:rjmp u_xx_x7           ;Sprungdistanz zu weit
u_xx_x8a:rjmp u_xx_x8           ;Sprungdistanz zu weit
u_xx_x9a:rjmp u_xx_x9           ;Sprungdistanz zu weit
u_xx_xaa:rjmp u_xx_xa           ;Sprungdistanz zu weit
u_xx_xba:rjmp u_xx_xb           ;Sprungdistanz zu weit
u_xx_xca:rjmp u_xx_xc           ;Sprungdistanz zu weit
u_xx_xda:rjmp u_xx_xd           ;Sprungdistanz zu weit
u_xx_xea:rjmp u_xx_xe           ;Sprungdistanz zu weit
u_xx_xfa:rjmp u_xx_xf           ;Sprungdistanz zu weit
u_xx_xha:rjmp u_xx_xh           ;Sprungdistanz zu weit
u_xx_xga:rjmp u_xx_xg           ;Sprungdistanz zu weit




u_xx_x0:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x0*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x0*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x1:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x1*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x1*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x2:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x2*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x2*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x3:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x3*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x3*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x4:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x4*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x4*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x5:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x5*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x5*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x6:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x6*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x6*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x7:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x7*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x7*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x8:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x8*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x8*2)	 ; Zeiger high laden
		rjmp u10
u_xx_x9:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_x9*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_x9*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xa:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xa*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xa*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xb:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xb*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xb*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xc:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xc*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xc*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xd:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xd*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xd*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xe:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xe*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xe*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xf:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xf*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xf*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xh:
;Ausgabe 1-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_xh*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xh*2)	 ; Zeiger high laden
		rjmp u10
u_xx_xg:  ;Anzeige aus
;Ausgabe 1-er StelleSekunde
		ldi ZL,LOW(uhr_xx_xg*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_xg*2)	 ; Zeiger high laden
		rjmp u10	    

u10: 	rcall LCD_u1				 ; Daten fr Anzeige einlesen
	
;---------------------------------------------------------------------------------------------	  
; *** Auswertung Sekunde 10-er Stelle ***
;---------------------------------------------------------------------------------------------	
um01: 	 
		mov tmp,tmp1			;Wert fr  10-er Stelle Sekunde Unterprogramm aus Dezimalzahl in BCD wandeln	
		lds tmp2,sek_10_hist	;Test, ob sich der aktuelle Wert zum Hist.- Wert gendert hat
		cp tmp,tmp2
		breq um10_1				;wenn keine nderung, dann zur nchsten Anzeigestelle
		
		sts sek_10_hist,tmp		;Historie speichern
		
				
		ldi tmp2,0b10000000		;Maske zum Ausblenden der vorherigen Anzeige lcd_u2:
	
		cpi	tmp,$0				;vergleiche Zhlerstand
		breq u_xx_0xa			;Anzeige Sekunde 10-er Stelle 0
		cpi	tmp,$1				;vergleiche Zhlerstand
		breq u_xx_1xa			;Anzeige Sekunde 10-er Stelle 1
		cpi	tmp,$2				;vergleiche Zhlerstand
		breq u_xx_2xa			;Anzeige Sekunde 10-er Stelle 2
		cpi	tmp,$3				;vergleiche Zhlerstand
		breq u_xx_3xa			;Anzeige Sekunde 10-er Stelle 3
		cpi	tmp,$4				;vergleiche Zhlerstand
		breq u_xx_4xa			;Anzeige Sekunde 10-er Stelle 4
		cpi	tmp,$5				;vergleiche Zhlerstand	
		breq u_xx_5xa			;Anzeige Sekunde 10-er Stelle 5
		cpi	tmp,$6				;vergleiche Zhlerstand
		breq u_xx_6xa			;Anzeige Sekunde 10-er Stelle 6
		cpi	tmp,$7				;vergleiche Zhlerstand
		breq u_xx_7xa			;Anzeige Sekunde 10-er Stelle 7
		cpi	tmp,$8				;vergleiche Zhlerstand	
		breq u_xx_8xa			;Anzeige Sekunde 10-er Stelle 8	
		cpi	tmp,$9				;vergleiche Zhlerstand
		breq u_xx_9xa			;Anzeige Sekunde 10-er Stelle 9
		cpi	tmp,$a				;vergleiche Zhlerstand
		breq u_xx_axa			;Anzeige Sekunde 10-er Stelle a
		cpi	tmp,$b				;vergleiche Zhlerstand
		breq u_xx_bxa			;Anzeige Sekunde 10-er Stelle b
		cpi	tmp,$c				;vergleiche Zhlerstand
		breq u_xx_cxa			;Anzeige Sekunde 10-er Stelle c
		cpi	tmp,$d				;vergleiche Zhlerstand
		breq u_xx_dxa			;Anzeige Sekunde 10-er Stelle d
		cpi	tmp,$e				;vergleiche Zhlerstand
		breq u_xx_exa			;Anzeige Sekunde 10-er Stelle e
		cpi	tmp,$f				;vergleiche Zhlerstand
		breq u_xx_fxa			;Anzeige Sekunde 10-er Stelle f
		cpi	tmp,$10				;vergleiche Zhlerstand
		breq u_xx_hxa			;Anzeige Sekunde 1-er Stelle "-"
		cpi	tmp,$ff				;vergleiche Zhlerstand
		breq u_xx_gxa			;Anzeige Sekunde 10-er Stelle ausgeschaltet
		rjmp u2					;Sicherheitsabfrage

um10_1: rjmp um10				;Sprungdistanz zu weit

u_xx_0xa:rjmp u_xx_0x
u_xx_1xa:rjmp u_xx_1x
u_xx_2xa:rjmp u_xx_2x
u_xx_3xa:rjmp u_xx_3x
u_xx_4xa:rjmp u_xx_4x
u_xx_5xa:rjmp u_xx_5x
u_xx_6xa:rjmp u_xx_6x
u_xx_7xa:rjmp u_xx_7x
u_xx_8xa:rjmp u_xx_8x
u_xx_9xa:rjmp u_xx_9x
u_xx_axa:rjmp u_xx_ax
u_xx_bxa:rjmp u_xx_bx
u_xx_cxa:rjmp u_xx_cx
u_xx_dxa:rjmp u_xx_dx
u_xx_exa:rjmp u_xx_ex
u_xx_fxa:rjmp u_xx_fx
u_xx_hxa:rjmp u_xx_hx
u_xx_gxa:rjmp u_xx_gx



u_xx_0x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_0x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_0x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_1x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_1x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_1x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_2x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_2x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_2x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_3x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_3x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_3x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_4x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_4x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_4x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_5x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_5x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_5x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_6x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_6x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_6x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_7x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_7x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_7x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_8x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_8x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_8x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_9x:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_9x*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_9x*2)	 ; Zeiger high laden
		rjmp u11
u_xx_ax:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_ax*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_ax*2)	 ; Zeiger high laden
		rjmp u11
u_xx_bx:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_bx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_bx*2)	 ; Zeiger high laden
		rjmp u11
u_xx_cx:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_cx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_cx*2)	 ; Zeiger high laden
		rjmp u11
u_xx_dx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_xx_dx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_dx*2)	 ; Zeiger high laden
		rjmp u11
u_xx_ex:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_ex*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_ex*2)	 ; Zeiger high laden
		rjmp u11
u_xx_fx:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_fx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_fx*2)	 ; Zeiger high laden
		rjmp u11
u_xx_hx:
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_hx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_hx*2)	 ; Zeiger high laden
		rjmp u11
u_xx_gx:  							 ; Anzeige aus
;Ausgabe 10-er Stelle Sekunde
		ldi ZL,LOW(uhr_xx_gx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xx_gx*2)	 ; Zeiger high laden
		rjmp u11		


u11: 	rcall LCD_u2				 ; Daten fr Anzeige einlesen
			
;---------------------------------------------------------------------------------------------
; *** Auswertung Minute 1-er Stelle ***
;---------------------------------------------------------------------------------------------
um10:
	  	sbrc modus_2,5	 ;berspringe nchsten Befehl wenn bit5 (von 0-7) von modus_2=0 -> wenn kein Count Down Timer aktiv- dann weiter
		rjmp ur126_6	 ;wenn Count Down Timer eingeschaltet, dann unterscheiden, ob Einstellmode oder Anzeigemode aktiv



; *************Sollwerte fr Minute umladen ******************
;------------------------------------- countdowntimer ----------------------------------------------------------
ur126_6:   lds tmp,countdowntimer
		   sbrc tmp,6		 			;berspringe nchsten Befehl wenn bit6 (von 0-7) von countdowntimer =0 -> countdowntimer beendet warten auf Neustart 
		   rjmp ur126_6_2	 			;Striche anzeigen und aktuellen Anzahl der Piezosignale
		   sbrc tmp,7		 			;berspringe nchsten Befehl wenn bit7 (von 0-7) von countdowntimer =1 ->5x Piezosignal ein luft 
		   rjmp ur126_6_2	 			;Striche anzeigen und aktuellen Anzahl der Piezosignale

		   sbrs tmp,0		 			;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer =1 ->Count Down Timer stellen
		   rjmp ur126_6_1	 			;kein Einstellmode, nur anzeigen
		   lds tmp2,cd_minute  	 		;Sollwert ->Count Down Timer stellen
		   lds tmp,countdowntimer
		   sbrs tmp,2	         		;berspringe nchsten Befehl wenn bit2 (von 0-7) von countdowntimer =1 ->Count Down Timer Stunde blinkt
		   rjmp ur122					;wenn gesetzt, dann Minute nicht blinken
		   lds tmp,tastencode_guelt		;gltiger tastencode 
		   cpi tmp,0x00					;00 = keine Taste bettigt und tasten entprellt und zeitverzgert
		   breq ur126_10				;Anzeige blinken lassen
		   cpi tmp,0x0C					;0x0C = fr Taste + und Taste - gleichzeitig bettigt -> muss schon blinken, wenn Count Down Timer Stellmodus eingeschaltet wird
		   breq ur126_10				;Anzeige blinken lassen
		   rjmp ur122					;darf nicht blinken, damit man whrend des Stellens die Anzeige sieht

ur126_6_1: lds tmp2,cd_minute 			;aktuellen Wert Count Down Timer Minute anzeigen
		   rjmp ur122		

ur126_6_2: ldi tmp,$10					; "-" anzeigen
		   ldi tmp1,$10					; "-" anzeigen
		   rjmp ur125


ur126_10: rjmp ur126				; Sprung zu weit

;--------------------- Wert fr blinken laden------------------------------------------------------------------------------

ur126:		lds tmp,imp
			sbrc tmp,2			    ;1,0 s bersprige nchsten Befehl, wenn bit 2 von impuls =0 
			rjmp ur123
			sbrc tmp,1			    ;0,5s  bersprige nchsten Befehl, wenn bit 1 von impuls =0 
			rjmp ur122
			rjmp us10

ur123:  	ldi tmp,$ff				;Anzeige aus
			ldi tmp1,$ff			;Anzeige aus
			rjmp ur125				


;---------------------------------------------------------------------------------------------------
ur122:
		sbrc modus_2,5	 			;berspringe nchsten Befehl wenn bit5 (von 0-7) von modus_2=1 -> Count Down Timer
		rjmp ur29_1	 			    ;in jedem Fall cd_minute laden

ur29_1:	lds tmp, cd_minute			;Minuten vom Count Down Timer anzeigen 
		rjmp ur129

ur129:	rcall dual12bcd				;dual in 2 Byte BCD wandeln
		rjmp ur125					
		

;-------------------------------------------------------------------------------------------------------------------
		 
ur125:	lds tmp2,min_01_hist	;Prfung, ob sich der aktuelle Wert zum Hist.- Wert gendert hat
		cp tmp,tmp2
		breq us110_1			;wenn keine nderung, dann zur nchsten Anzeigestelle

   		sts min_01_hist,tmp		;Historie speichern	

		ldi tmp2,0b10000000		;Maske zum Ausblenden der vorherigen Anzeige lcd_u3:

		cpi	tmp,$0				;vergleiche Zhlerstand
		breq u_x0_xx			;Anzeige Minute 1-er Stelle 0
		cpi	tmp,$1				;vergleiche Zhlerstand
		breq u_x1_xx			;Anzeige Minute 1-er Stelle 1
		cpi	tmp,$2				;vergleiche Zhlerstand
		breq u_x2_xx			;Anzeige Minute 1-er Stelle 2
		cpi	tmp,$3				;vergleiche Zhlerstand
		breq u_x3_xx			;Anzeige Minute 1-er Stelle 3
		cpi	tmp,$4				;vergleiche Zhlerstand
		breq u_x4_xx			;Anzeige Minute 1-er Stelle 4
		cpi	tmp,$5				;vergleiche Zhlerstand	
		breq u_x5_xx			;Anzeige Minute 1-er Stelle 5
		cpi	tmp,$6				;vergleiche Zhlerstand
		breq u_x6_xx			;Anzeige Minute 1-er Stelle 6
		cpi	tmp,$7				;vergleiche Zhlerstand
		breq u_x7_xx			;Anzeige Minute 1-er Stelle 7
		cpi	tmp,$8				;vergleiche Zhlerstand	
		breq u_x8_xx			;Anzeige Minute 1-er Stelle 8	
		cpi	tmp,$9				;vergleiche Zhlerstand
		breq u_x9_xx			;Anzeige Minute 1-er Stelle 9
		cpi	tmp,$a				;vergleiche Zhlerstand
		breq u_xa_xx			;Anzeige Minute 1-er Stelle a
		cpi	tmp,$b				;vergleiche Zhlerstand
		breq u_xb_xx			;Anzeige Minute 1-er Stelle b
		cpi	tmp,$c				;vergleiche Zhlerstand
		breq u_xc_xx			;Anzeige Minute 1-er Stelle c
		cpi	tmp,$d				;vergleiche Zhlerstand
		breq u_xd_xx			;Anzeige Minute 1-er Stelle d
		cpi	tmp,$e				;vergleiche Zhlerstand
		breq u_xe_xx			;Anzeige Minute 1-er Stelle e
		cpi	tmp,$f				;vergleiche Zhlerstand
		breq u_xf_xx			;Anzeige Minute 1-er Stelle f
		cpi	tmp,$10				;vergleiche Zhlerstand
		breq u_xh_xx			;Anzeige Minute 1-er Stelle "-"
		cpi	tmp,$ff				;vergleiche Zhlerstand
		breq u_xg_xx			;Anzeige Minute 1-er Stelle ausgeschaltet
		rjmp u2					;Sicherheitsabfrage

us110_1: rjmp us110				;Sprungdistanz zu weit


u_x0_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x0_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x0_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x1_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x1_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x1_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x2_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x2_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x2_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x3_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x3_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x3_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x4_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x4_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x4_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x5_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x5_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x5_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x6_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x6_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x6_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x7_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x7_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x7_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x8_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x8_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x8_xx*2)	 ; Zeiger high laden
		rjmp u12
u_x9_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_x9_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_x9_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xa_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xa_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xa_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xb_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xb_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xb_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xc_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xc_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xc_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xd_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xd_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xd_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xe_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xe_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xe_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xf_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xf_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xf_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xh_xx:
;Ausgabe 1-er Stelle Minute
		ldi ZL,LOW(uhr_xh_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xh_xx*2)	 ; Zeiger high laden
		rjmp u12
u_xg_xx:							 ; Anzeige aus
;Ausgabe 1-er Stelle Minute	aus
		ldi ZL,LOW(uhr_xg_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_xg_xx*2)	 ; Zeiger high laden
		rjmp u12	

us110:  rjmp us01



u12: 	rcall LCD_u3				 ; Daten fr Anzeige einlesen
	
	;---------------------------------------------------------------------------------------------
; *** Auswertung Minute 10-er Stelle ***
;---------------------------------------------------------------------------------------------
us01: 	
		mov tmp,tmp1			;Wert fr  10-er Stelle Stunden Unterprogramm aus Dezimalzahl in BCD wandeln
		lds tmp2,min_10_hist	;test, ob sich der aktuelle wert zum Hist.- Wert gendert hat
		cp tmp,tmp2
   		breq us10_1				;wenn keine nderung, dann zur nchsten Anzeigestelle

		sts min_10_hist,tmp	    ;Historie speichern
	
		cpi	tmp,$0				;vergleiche Zhlerstand
		breq u_0x_xx			;Anzeige Minute 10-er Stelle 0   ;wenn 0 , dann keine Anzeige
		cpi	tmp,$1				;vergleiche Zhlerstand
		breq u_1x_xx			;Anzeige Minute 10-er Stelle 1
		cpi	tmp,$2				;vergleiche Zhlerstand
		breq u_2x_xx			;Anzeige Minute 10-er Stelle 2
		cpi	tmp,$3				;vergleiche Zhlerstand
		breq u_3x_xx			;Anzeige Minute 10-er Stelle 3
		cpi	tmp,$4				;vergleiche Zhlerstand
		breq u_4x_xx			;Anzeige Minute 10-er Stelle 4
		cpi	tmp,$5				;vergleiche Zhlerstand
		breq u_5x_xx			;Anzeige Minute 10-er Stelle 5
		cpi	tmp,$6				;vergleiche Zhlerstand
		breq u_6x_xx			;Anzeige Minute 10-er Stelle 6
		cpi	tmp,$7				;vergleiche Zhlerstand
		breq u_7x_xx			;Anzeige Minute 10-er Stelle 7
		cpi	tmp,$8				;vergleiche Zhlerstand
		breq u_8x_xx			;Anzeige Minute 10-er Stelle 8
		cpi	tmp,$9				;vergleiche Zhlerstand
		breq u_9x_xx			;Anzeige Minute 10-er Stelle 9
		cpi	tmp,$a				;vergleiche Zhlerstand
		breq u_ax_xx			;Anzeige Minute 10-er Stelle a
		cpi	tmp,$b				;vergleiche Zhlerstand
		breq u_bx_xx			;Anzeige Minute 10-er Stelle b
		cpi	tmp,$c				;vergleiche Zhlerstand
		breq u_cx_xx			;Anzeige Minute 10-er Stelle c
		cpi	tmp,$d				;vergleiche Zhlerstand
		breq u_dx_xx			;Anzeige Minute 10-er Stelle d
		cpi	tmp,$e				;vergleiche Zhlerstand
		breq u_ex_xx			;Anzeige Minute 10-er Stelle e
		cpi	tmp,$f				;vergleiche Zhlerstand
		breq u_fx_xx			;Anzeige Minute 10-er Stelle f
		cpi	tmp,$10				;vergleiche Zhlerstand
		breq u_hx_xx			;Anzeige Minute 10-er Stelle "-"
		cpi	tmp,$ff				;vergleiche Zhlerstand
		breq u_gx_xx			;Anzeige Minute 10-er Stelle ausgeschaltet
		rjmp u2					;Sicherheitsabfrage

us10_1: rjmp us10				;Sprungdistanz zu weit


u_0x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_gx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_gx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_1x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_1x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_1x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_2x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_2x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_2x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_3x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_3x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_3x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_4x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_4x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_4x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_5x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_5x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_5x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_6x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_6x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_6x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_7x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_7x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_7x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_8x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_8x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_8x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_9x_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_9x_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_9x_xx*2)	 ; Zeiger high laden
		rjmp u13
u_ax_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_ax_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_ax_xx*2)	 ; Zeiger high laden
		rjmp u13
u_bx_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_bx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_bx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_cx_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_cx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_cx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_dx_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_dx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_dx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_ex_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_ex_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_ex_xx*2)	 ; Zeiger high laden
		rjmp u13
u_fx_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_fx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_fx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_hx_xx:
;Ausgabe 10-er Stelle Minute
		ldi ZL,LOW(uhr_hx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_hx_xx*2)	 ; Zeiger high laden
		rjmp u13
u_gx_xx:   							 ; Anzeige aus
;Ausgabe 10-er Stelle Minute aus
		ldi ZL,LOW(uhr_gx_xx*2)		 ; Zeiger low laden
		ldi ZH,HIGH(uhr_gx_xx*2)	 ; Zeiger high laden
		rjmp u13

u13: 	rcall LCD_u4				 ; Daten fr Anzeige einlesen
	
us10:   rjmp u2







;-------------------------------------------------------------------------------
;***** Unterprogramme *****
;-------------------------------------------------------------------------------

; ***Dezimalzahl in BCD wandeln***
dual12bcd: 	clr tmp1		;hunderter lschen
dual12bcd1:	cpi tmp,100		;hunderter probe
		   	brlo dual12bcd2	;dual < 100 :fertig
		   	subi tmp,100	;dual >= 100 :abziehen
		   	inc tmp1		;hunderter zhlen
		   	rjmp dual12bcd1	;bis dual < 100
dual12bcd2:	clr tmp2		;zehner lschen
dual12bcd3: cpi tmp,10		;zehnerprobe
			brlo dual12bcd4	;dual < 10 :fertig
			subi tmp,10		;dual >= 10 :abziehen
		   	inc tmp1		;zehner zhlen
			rjmp dual12bcd3	;bis dual < 10
dual12bcd4: nop				;tmp1 = zehner 
			nop				;tmp  = einer
			ret


;*** Daten fr Anzeige  Sekunden 1-er, zusammenstellen***
lcd_u1:
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR0				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR0,tmp				 ;ausgabe	
		ret

;*** Daten fr Anzeige Sekunden 10-er zusammenstellen***
lcd_u2:
		adiw Zl,1	
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR1				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR1,tmp				 ;ausgabe	
		ret

;*** Daten fr Anzeige Minute 1-er zusammenstellen***
lcd_u3:
		adiw Zl,2	
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR2				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR2,tmp				 ;ausgabe	
		ret
		
;*** Daten fr Anzeige Minute 10-er zusammenstellen***
lcd_u4:
		ldi tmp2,0b01111111			 ;Maske zum Ausblenden der vorherigen Anzeige lcd_u4:
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR0				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR0,tmp				 ;ausgabe	

		ldi tmp2,0b01111111			 ;Maske zum Ausblenden der vorherigen Anzeige lcd_u4:
		adiw Zl,1	
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR1				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR1,tmp				 ;ausgabe	

		ldi tmp2,0b01111111			 ;Maske zum Ausblenden der vorherigen Anzeige lcd_u4:
		adiw Zl,1	
		lpm							 ;Wert in R0 (Vordefiniert) laden 
		lds tmp,LCDDR2				 ;alten Zustand vom LCD Register laden
		and tmp,tmp2				 ;alte Bits durch Maske lschen
		or tmp,rlpm					 ;ODER verknpfung mit eingelesenem wert
		sts LCDDR2,tmp				 ;ausgabe	
		ret



;;*** Uhr stellen ***
uhr_stellen:
;--------------------------------------------------------------------------------
;wenn Taste + oder Taste - gedrckt wurde, dann 0,25s warten, bevor bei den nchsten 0,25s wieder gezhlt wird 
		lds tmp2,updowncount		;erst beim 2. 0,25s Impuls nach Wechsel von Stepfunktion auf Dauerfunktion darf gezhlt werden 
		cpi tmp2,0					;es mssen mindestens 2 Impulse vergangen sein, bis weiter gezhlt wird
		brne ur18


;--------------------------------------------------------------------------------
; steigende Flanke Taste bettigt erkennen 
		lds tmp,tastencode_guelt 	;gltiger tastencode 
		cpi tmp,0x04				;4 = Taste + bettigt und Tasten entprellt und zeitverzgert
		breq ur13_1
		cpi tmp,0x08				;8 = Tasten -  bettigt und Tasten entprellt und zeitverzgert
		breq ur13_1					;Test ob fallende Flanke vorhanden ist

; keine steigende Flanke vorhanden
ur13_3:	lds tmp,tastencode_guelt 	;gltiger tastencode 
		cpi tmp,0					;0 = keine Taste bettigt
		breq ur13_2					;Timeout hochzhlen
		cpi tmp,0x04				;4 = Taste + bettigt und Tasten entprellt und zeitverzgert
		breq ur13
		cpi tmp,0x08				;8 = Taste - bettigt und Tasten entprellt und zeitverzgert
		breq ur13					;Test ob fallende Flanke vorhanden ist
		rjmp ur19_1

ur13_1: lds tmp,tastencode_guelt_hist	;gltiger tastencode 
		cpi tmp,0x00				;vorher war keine Taste bettigt
		breq ur13_4					;steigende Flanke Taste erkannt				
		rjmp ur13_3					;keine steigende Flanke vorhanden

;steigende Flanke von Taste erkannt
ur13_4:	ldi tmp1,0b00000001
		sts updowncount,tmp1		;setze auf 1 damit beim nchsten 0,25s Impuls noch nicht gezhlt wird erst beim bernchsten 
		rjmp ur18_3  

;--------------------------------------------------------------------------------
; Wartezeit 1x 0,25s, bevor beim nchsten 0,25s Impuls weitergezhlt wird
ur18:	lds tmp,imp
		sbrs tmp,0		  		    ;0,25s bersprige nchsten Befehl, wenn bit 1 von impuls =0 
		rjmp ur19_1

		inc tmp2
		sts updowncount,tmp2
		clr tmp2					; einen Impuls warten, bevor es wieder weiter geht
		sts updowncount,tmp2
		rjmp ur19_1

; Timeout Uhr stellen 
ur13_2:	lds tmp,imp
		sbrc tmp,0		  		    ;0,25s bersprige nchsten Befehl, wenn bit 1 von impuls =0 
		rjmp ur27
		rjmp ur19_1

;Timeout hochzhlen
ur27: 	lds tmp,up_timeout
		inc tmp
		sts up_timeout,tmp
		cpi tmp,56					;wenn 56 x0,25s=14s Sekunden vergangen, dann Modus Uhr stellen beenden
		breq ur20_1
		rjmp ur19_1					;weiter im Programm


ur20_1:	rjmp ur20					;sprung zu weit
	


;wurde Taste + oder Taste - bettigt ?
ur13:	lds tmp,imp					; zahlen werden im 0.25s Takt hochgezhlt
		sbrs tmp,0			  		;0,25 s bersprige nchsten Befehl, wenn bit 1 von impuls =1
		rjmp ur19_1
ur18_3: lds tmp2,up_modus_1
		sbrc tmp2,2	     		    ;berspringe nchsten Befehl wenn bit2 (von 0-7) von modus_1=0 ->Minute blinkt
		rjmp ur12					;wenn gesetzt, dann Stunden zhlen
		rjmp ur16					;wenn nicht gesetzt, dann Minuten zhlen

;Minute zhlen 
ur12:  	lds tmp,tastencode_guelt 	;gltiger tastencode 
		cpi tmp,0x04				;4 = Taste + bettigt und Tasten entprellt und zeitverzgert
		breq ur12_1
		cpi tmp,0x08				;8 = Taste - bettigt und Tasten entprellt und zeitverzgert
		breq ur12_2
		rjmp ur19_1

;Minute hochzhlen mit Taste + 	
ur12_1:	clr tmp						;Zhler auf 0 stellen
		sts up_timeout,tmp
		lds tmp,up_minute
		inc tmp 
		cpi tmp,20					;Minute =20 ? 
		breq ur21
		sts up_minute,tmp			;Minutenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm
ur21:	ldi tmp,0
		sts up_minute,tmp			;Minutenwert im SRAM ablege
		rjmp ur19_1

;Minute runterzhlen mit Taste -
ur12_2: clr tmp						;Zhler auf 0 stellen
		sts up_timeout,tmp
		lds tmp,up_minute
		dec tmp 
		cpi tmp,0xFF				;Minute =0 ? (berlauf von 0 zu FF)
		breq ur12_3
		sts up_minute,tmp			;Minutenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm
ur12_3:	ldi tmp,19
		sts up_minute,tmp			;Minutenwert im SRAM ablege
		rjmp ur19_1



;Sekunde hochzhlen 
ur16:	lds tmp,tastencode_guelt 	;gltiger tastencode 
		cpi tmp,0x04				;4 = Taste + bettigt und Tasten entprellt und zeitverzgert
		breq ur16_1
		cpi tmp,0x08				;8 = Taste - bettigt und Tasten entprellt und zeitverzgert
		breq ur16_5
		rjmp ur19_1


;Sekunde hochzhlen mit Taste + 
ur16_1:	clr tmp						;Zhler auf 0 stellen
		sts up_timeout,tmp
		lds tmp,up_sekunde
		lds tmp2,up_modus_1
		sbrc tmp2,0	   		      	;berspringe nchsten Befehl wenn bit0 (von 0-7) von modus=0 ->Uhr stellen aus
		rjmp ur16_3					;im Uhrstellmode wird jede sekunde gezhlt
		inc tmp						;im Timerstellmode wird jede 10. sekunde gezhlt
		inc tmp
		inc tmp
		inc tmp
		inc tmp
		inc tmp
		inc tmp
		inc tmp
		inc tmp
ur16_3:	inc tmp
		cpi tmp,60					;sekunde =60 ? 
		breq ur16_4
		sts up_sekunde,tmp			;Sekundenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm
ur16_4:	ldi tmp,0
		sts up_sekunde,tmp			;Sekundenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm


;Sekunde runtezhlen mit Taste - 
ur16_5: clr tmp						;Zhler auf 0 stellen
		sts up_timeout,tmp
		lds tmp,up_sekunde
		lds tmp2,up_modus_1
		sbrc tmp2,0	         		;berspringe nchsten Befehl wenn bit0 (von 0-7) von modus=0 ->Uhr stellen aus
		rjmp ur16_6					;im Uhrstellmode wird jede Minute gezhlt
		dec tmp						;im Timerstellmode wird jede 10. Minute gezhlt
		dec tmp
		dec tmp
		dec tmp
		dec tmp
		dec tmp
		dec tmp
		dec tmp
		dec tmp
ur16_6:	dec tmp
		cpi tmp,0xFF				;Sekunde =255 ? (berlauf von 0 zu FF bei schrittweise zhlen)
		breq ur16_7
		cpi tmp,0xF6				;Sekunde =246 ? (berlauf von 0 zu F6 bei 10-er Schritte zhlen)
		breq ur16_8
		sts up_sekunde,tmp			;Sekundenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm
ur16_7:	ldi tmp,59
		sts up_sekunde,tmp			;sekundenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm

ur16_8:	ldi tmp,50
		sts up_sekunde,tmp			;Sekundenwert im SRAM ablege
		rjmp ur19_1					;weiter im Programm



;**** muss ausserhalb vom Programm gemacht werden ****

;Uhrstellmodus beenden (Modus Uhr stellen verlassen)
ur20:	ldi tmp1,0b00000001      	;bit setzen, wenn stellmodus beendet werden soll 
		ret

ur19_1: clr tmp1					;Stellmodus soll nicht beendet werden
		ret





















;-------------------------------------------------------------------------------
;***** Anzeige *****
;-------------------------------------------------------------------------------


u2: 


; ****Doppelpunkt anzeigen	***	 

;Blinken 
		lds tmp,countdowntimer
     	sbrc tmp,6		 ;berspringe nchsten Befehl wenn bit6 (von 0-7) von countdowntimer =0 ->countdowntimer beendet warten auf Neustart 
		rjmp u4		 	 ;Striche anzeigen und aktuellen Anzahl der Piezosignale
     	sbrc tmp,7		 ;berspringe nchsten Befehl wenn bit7 (von 0-7) von countdowntimer =0 ->5x Piezosignal ein luft 
		rjmp u4		 	 ;Striche anzeigen und aktuellen Anzahl der Piezosignale
		sbrc tmp,0		 ;berspringe nchsten Befehl wenn bit0 (von 0-7) von countdowntimer =0 ->Count Down Timer stellen
		rjmp u3			 ;Doppelpunkt stndig ein
		rjmp u6			 ;wenn 0 dann Sprung zur Uhr


u6:		lds tmp,imp
		sbrc tmp,2				    ;1,0 s bersprige nchsten Befehl, wenn bit 2 von impuls =0 
		rjmp u4
		sbrc tmp,1				    ;0,5s  bersprige nchsten Befehl, wenn bit 1 von impuls =0 
		rjmp u3
		rjmp u5

u4:		lds tmp,LCDDR3				 ;alten Zustand vom LCD Register laden 
		cbr tmp,0b00000001			 ;Doppelpunkt LCDDR16 Bit 6 lschen
		sts LCDDR3,tmp				 ;ausgabe
		rjmp u5
u3: 	lds tmp,LCDDR3				 ;alten Zustand vom LCD Register laden 
		sbr tmp,0b00000001			 ;Doppelpunkt LCDDR16 Bit 6 setzen
		sts LCDDR3,tmp				 ;ausgabe
		rjmp u5

u5:  	nop ; Ende









